module Ygg
  module Dns
    class Zones < ActiveResource::Hel::Resource

      def tld
        name.split('.').last
      end

      def zonefile
        File.join(name.split('.').reverse) +  '.addr'
      end

      def master_servers
        zone_servers.select { |s| s.master }
      end

      def zone_file
        get(:zone_file)['file']
      end

      def import_static(zone, text)
        post(:import_static, {}, {:zone => zone, :text => text})
      end

      def import_records(zone, text)
        post(:import, {}, {:zone => zone, :text => text, :destroy => :true})
      end

      class << self

        def find_by_name(name)
          find(:first, :params => {:name => name})
        end


        #
        # last update timestamp for the resource
        #
        def last_update
          r = get(:state)
          if r.has_key?('last_update')
            DateTime.parse(r['last_update'])
          else
            DateTime.now
          end
        end
      end
    end
  end
end