module Bender
  class Plugin

    attr_reader :config, :base_config, :svc_config
    attr_reader :log


    def initialize(env)

      @host_identity, @service = env[:host_identity], env[:service]
      @config, @base_config, @svc_config = env[:config], env[:base_config], env[:svc_config]
      @log, @dry_run = env[:log], env[:dry_run]

      log.debug "- initialized plugin '#{self.class.name}'"
    end

    def dry_run?
      @dry_run
    end

    def provision(env)
      log.debug "- provision plugin '#{self.class.name}'"

    end

    def update(env)
      log.debug "- update plugin '#{self.class.name}'"

    end

    def maintenance(env)
      log.debug "- maintenance plugin '#{self.class.name}'"

    end

    private
    #######

    def host_home_path(host)
      File.join(base_path, svc_config[:service_paths][:storage],  svc_config[:service_paths][:vhosts], host.uri)
    end

    def base_path
      base_config[:base_path] || ''
    end

  end
end