require 'activeresource/hel'

module Bender
  module Resources

    def self.setup(url, options = {})
      
      raise ArgumentError, "URL is mandatory." unless url
      raise ArgumentError, "Authentication credentials are mandatory." unless options[:identity] &&
                                                                              options[:secret]

      ActiveResource::Hel::Resource.read_timeout = options.fetch(:timeout, 60)

      ActiveResource::Hel::Resource.configurations = {
        hel: {
          site: url,
          identity: options[:identity],
          secret: options[:secret]
        }
      }
      ActiveResource::Hel::Resource.use_configuration :hel
      ActiveResource::Hel::Resource.logger = ::Tomte.logger
      ActiveResource::Hel::Resource.guess_embedded_types = true

      models_path = "#{::Tomte.config.core[:application_lib]}/bender/models/**/*.rb"
      Dir[models_path].each {|f| require f}

    end
  end
end